---
title: Element.matches()
slug: Web/API/Element/matches
tags:
  - API
  - DOM
  - Element
  - Method
  - Reference
  - msMatchesSelector
  - webkitMatchesSelector
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>matches()</code></strong> method checks to see if the {{domxref("Element")}} would be selected by the provided <code><var>selectorString</var></code> -- in other words -- checks if the element "is" the selector.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>result</var> = <var>element</var>.matches(<var>selectorString</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<p><code><var>selectorString</var></code> is a string representing the selector to test.</p>

<h3 id="Return_value">Return value</h3>

<p><code><var>result</var></code> is a {{domxref("Boolean")}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>SYNTAX_ERR</code></dt>
 <dd>The specified selector string is invalid.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: html notranslate">&lt;ul id="birds"&gt;
  &lt;li&gt;Orange-winged parrot&lt;/li&gt;
  &lt;li class="endangered"&gt;Philippine eagle&lt;/li&gt;
  &lt;li&gt;Great white pelican&lt;/li&gt;
&lt;/ul&gt;

&lt;script type="text/javascript"&gt;
  var birds = document.getElementsByTagName('li');

  for (var i = 0; i &lt; birds.length; i++) {
    if (birds[i].matches('.endangered')) {
      console.log('The ' + birds[i].textContent + ' is endangered!');
    }
  }
&lt;/script&gt;
</pre>

<p>This will log "The Philippine eagle is endangered!" to the console, since the element has indeed a <code>class</code> attribute with value <code>endangered</code>.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>For browsers that do not support <code>Element.matches()</code> or <code>Element.matchesSelector()</code>, but include support for <code>document.querySelectorAll()</code>, a polyfill exists:</p>

<pre class="brush: js notranslate">if (!Element.prototype.matches) {
  Element.prototype.matches =
      Element.prototype.matchesSelector ||
      Element.prototype.mozMatchesSelector ||
      Element.prototype.msMatchesSelector ||
      Element.prototype.oMatchesSelector ||
      Element.prototype.webkitMatchesSelector ||
      function(s) {
        var matches = (this.document || this.ownerDocument).querySelectorAll(s),
            i = matches.length;
        while (--i &gt;= 0 &amp;&amp; matches.item(i) !== this) {}
        return i &gt; -1;
      };
}</pre>

<p>However, given the practicality of supporting older browsers, the following should suffice for most (if not all) practical cases (i.e. IE9+ support).</p>

<pre class="brush: js notranslate">if (!Element.prototype.matches) {
  Element.prototype.matches = Element.prototype.msMatchesSelector ||
                              Element.prototype.webkitMatchesSelector;
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-matches', 'Element.prototype.matches')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.matches")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>
  <div class="syntaxbox"><a href="/en-US/docs/Web/Guide/CSS/Getting_started/Selectors">The syntax of Selectors</a></div>
 </li>
 <li>
  <div class="syntaxbox">Other methods that take selectors: {{domxref("element.querySelector()")}} and {{domxref("element.closest()")}}.</div>
 </li>
</ul>
